require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ENDIAN_H_)) {
    eval 'sub _MACHINE_ENDIAN_H_ () {1;}' unless defined(&_MACHINE_ENDIAN_H_);
    require 'sys/cdefs.ph';
    require 'sys/_types.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub _QUAD_HIGHWORD () {1;}' unless defined(&_QUAD_HIGHWORD);
    eval 'sub _QUAD_LOWWORD () {0;}' unless defined(&_QUAD_LOWWORD);
    eval 'sub _LITTLE_ENDIAN () {1234;}' unless defined(&_LITTLE_ENDIAN);
    eval 'sub _BIG_ENDIAN () {4321;}' unless defined(&_BIG_ENDIAN);
    eval 'sub _PDP_ENDIAN () {3412;}' unless defined(&_PDP_ENDIAN);
    eval 'sub _BYTE_ORDER () { &_LITTLE_ENDIAN;}' unless defined(&_BYTE_ORDER);
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub LITTLE_ENDIAN () { &_LITTLE_ENDIAN;}' unless defined(&LITTLE_ENDIAN);
	eval 'sub BIG_ENDIAN () { &_BIG_ENDIAN;}' unless defined(&BIG_ENDIAN);
	eval 'sub PDP_ENDIAN () { &_PDP_ENDIAN;}' unless defined(&PDP_ENDIAN);
	eval 'sub BYTE_ORDER () { &_BYTE_ORDER;}' unless defined(&BYTE_ORDER);
    }
    if(defined(&__GNUCLIKE_ASM)  && defined(&__GNUCLIKE_BUILTIN_CONSTANT_P)) {
	eval 'sub __byte_swap_int_var {
	    my($x) = @_;
    	    eval q( &__extension__ ({  &register  &__uint32_t  &__X = ($x);  &__asm (\\"bswap %0\\" : \\"+r\\" ( &__X));  &__X; }));
	}' unless defined(&__byte_swap_int_var);
	if(defined(&__OPTIMIZE__)) {
	    eval 'sub __byte_swap_int_const {
	        my($x) = @_;
    		eval q((((($x) & 0xff000000) >> 24) | ((($x) & 0xff0000) >> 8) | ((($x) & 0xff00) << 8) | ((($x) & 0xff) << 24)));
	    }' unless defined(&__byte_swap_int_const);
	    eval 'sub __byte_swap_int {
	        my($x) = @_;
    		eval q(( &__builtin_constant_p($x) ?  &__byte_swap_int_const($x) :  &__byte_swap_int_var($x)));
	    }' unless defined(&__byte_swap_int);
	} else {
	    eval 'sub __byte_swap_int {
	        my($x) = @_;
    		eval q( &__byte_swap_int_var($x));
	    }' unless defined(&__byte_swap_int);
	}
	eval 'sub __byte_swap_long_var {
	    my($x) = @_;
    	    eval q( &__extension__ ({  &register  &__uint64_t  &__X = ($x);  &__asm (\\"bswap %0\\" : \\"+r\\" ( &__X));  &__X; }));
	}' unless defined(&__byte_swap_long_var);
	if(defined(&__OPTIMIZE__)) {
	    eval 'sub __byte_swap_long_const {
	        my($x) = @_;
    		eval q(((($x >> 56) | (($x >> 40) & 0xff00) | (($x >> 24) & 0xff0000) | (($x >> 8) & 0xff000000) | (($x << 8) & (0xff << 32)) | (($x << 24) & (0xff << 40)) | (($x << 40) & (0xff << 48)) | (($x << 56)))));
	    }' unless defined(&__byte_swap_long_const);
	    eval 'sub __byte_swap_long {
	        my($x) = @_;
    		eval q(( &__builtin_constant_p($x) ?  &__byte_swap_long_const($x) :  &__byte_swap_long_var($x)));
	    }' unless defined(&__byte_swap_long);
	} else {
	    eval 'sub __byte_swap_long {
	        my($x) = @_;
    		eval q( &__byte_swap_long_var($x));
	    }' unless defined(&__byte_swap_long);
	}
	eval 'sub __bswap64 {
	    my($_x) = @_;
    	    eval q({ ( &__byte_swap_long($_x)); });
	}' unless defined(&__bswap64);
	eval 'sub __bswap32 {
	    my($_x) = @_;
    	    eval q({ ( &__byte_swap_int($_x)); });
	}' unless defined(&__bswap32);
	eval 'sub __bswap16 {
	    my($_x) = @_;
    	    eval q({ ($_x << 8| $_x >> 8); });
	}' unless defined(&__bswap16);
	eval 'sub __htonl {
	    my($x) = @_;
    	    eval q( &__bswap32($x));
	}' unless defined(&__htonl);
	eval 'sub __htons {
	    my($x) = @_;
    	    eval q( &__bswap16($x));
	}' unless defined(&__htons);
	eval 'sub __ntohl {
	    my($x) = @_;
    	    eval q( &__bswap32($x));
	}' unless defined(&__ntohl);
	eval 'sub __ntohs {
	    my($x) = @_;
    	    eval q( &__bswap16($x));
	}' unless defined(&__ntohs);
    } else {
	eval 'sub _BYTEORDER_FUNC_DEFINED () {1;}' unless defined(&_BYTEORDER_FUNC_DEFINED);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
