require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MATH_H_)) {
    eval 'sub _MATH_H_ () {1;}' unless defined(&_MATH_H_);
    require 'sys/cdefs.ph';
    require 'sys/_types.ph';
    require 'machine/_limits.ph';
    if( &__GNUC_PREREQ__(3, 3) || (defined(&__INTEL_COMPILER)  && (defined(&__INTEL_COMPILER) ? &__INTEL_COMPILER : undef) >= 800)) {
	eval 'sub __MATH_BUILTIN_CONSTANTS () {1;}' unless defined(&__MATH_BUILTIN_CONSTANTS);
    }
    if( &__GNUC_PREREQ__(3, 0)  && !defined(&__INTEL_COMPILER)) {
	eval 'sub __MATH_BUILTIN_RELOPS () {1;}' unless defined(&__MATH_BUILTIN_RELOPS);
    }
    if(defined(&__MATH_BUILTIN_CONSTANTS)) {
	eval 'sub HUGE_VAL () { &__builtin_huge_val();}' unless defined(&HUGE_VAL);
    } else {
	eval 'sub HUGE_VAL () {( ($__infinity->{__ud}));}' unless defined(&HUGE_VAL);
    }
    if((defined(&__ISO_C_VISIBLE) ? &__ISO_C_VISIBLE : undef) >= 1999) {
	eval 'sub FP_ILOGB0 () {(- &__INT_MAX);}' unless defined(&FP_ILOGB0);
	eval 'sub FP_ILOGBNAN () { &__INT_MAX;}' unless defined(&FP_ILOGBNAN);
	if(defined(&__MATH_BUILTIN_CONSTANTS)) {
	    eval 'sub HUGE_VALF () { &__builtin_huge_valf();}' unless defined(&HUGE_VALF);
	    eval 'sub HUGE_VALL () { &__builtin_huge_vall();}' unless defined(&HUGE_VALL);
	    eval 'sub INFINITY () { &__builtin_inff();}' unless defined(&INFINITY);
	    eval 'sub NAN () { &__builtin_nanf("");}' unless defined(&NAN);
	} else {
	    eval 'sub HUGE_VALF () { &HUGE_VAL;}' unless defined(&HUGE_VALF);
	    eval 'sub HUGE_VALL () { &HUGE_VAL;}' unless defined(&HUGE_VALL);
	    eval 'sub INFINITY () { &HUGE_VALF;}' unless defined(&INFINITY);
	    eval 'sub NAN () {( ($__nan->{__uf}));}' unless defined(&NAN);
	}
	eval 'sub MATH_ERRNO () {1;}' unless defined(&MATH_ERRNO);
	eval 'sub MATH_ERREXCEPT () {2;}' unless defined(&MATH_ERREXCEPT);
	eval 'sub math_errhandling () { &MATH_ERREXCEPT;}' unless defined(&math_errhandling);
	if(defined(&__ia64__) || defined(&__sparc64__)) {
	    eval 'sub FP_FAST_FMA () {1;}' unless defined(&FP_FAST_FMA);
	}
	if(defined(&__ia64__)) {
	    eval 'sub FP_FAST_FMAL () {1;}' unless defined(&FP_FAST_FMAL);
	}
	eval 'sub FP_FAST_FMAF () {1;}' unless defined(&FP_FAST_FMAF);
	eval 'sub FP_INFINITE () {0x1;}' unless defined(&FP_INFINITE);
	eval 'sub FP_NAN () {0x2;}' unless defined(&FP_NAN);
	eval 'sub FP_NORMAL () {0x4;}' unless defined(&FP_NORMAL);
	eval 'sub FP_SUBNORMAL () {0x8;}' unless defined(&FP_SUBNORMAL);
	eval 'sub FP_ZERO () {0x10;}' unless defined(&FP_ZERO);
	eval 'sub fpclassify {
	    my($x) = @_;
    	    eval q((($sizeof{$x} == $sizeof{\'float\'}) ?  &__fpclassifyf($x) : ($sizeof{$x} == $sizeof{\'double\'}) ?  &__fpclassifyd($x) :  &__fpclassifyl($x)));
	}' unless defined(&fpclassify);
	eval 'sub isfinite {
	    my($x) = @_;
    	    eval q((($sizeof{$x} == $sizeof{\'float\'}) ?  &__isfinitef($x) : ($sizeof{$x} == $sizeof{\'double\'}) ?  &__isfinite($x) :  &__isfinitel($x)));
	}' unless defined(&isfinite);
	eval 'sub isinf {
	    my($x) = @_;
    	    eval q((($sizeof{$x} == $sizeof{\'float\'}) ?  &__isinff($x) : ($sizeof{$x} == $sizeof{\'double\'}) ?  &isinf($x) :  &__isinfl($x)));
	}' unless defined(&isinf);
	eval 'sub isnan {
	    my($x) = @_;
    	    eval q((($sizeof{$x} == $sizeof{\'float\'}) ?  &isnanf($x) : ($sizeof{$x} == $sizeof{\'double\'}) ?  &isnan($x) :  &__isnanl($x)));
	}' unless defined(&isnan);
	eval 'sub isnormal {
	    my($x) = @_;
    	    eval q((($sizeof{$x} == $sizeof{\'float\'}) ?  &__isnormalf($x) : ($sizeof{$x} == $sizeof{\'double\'}) ?  &__isnormal($x) :  &__isnormall($x)));
	}' unless defined(&isnormal);
	if(defined(&__MATH_BUILTIN_RELOPS)) {
	    eval 'sub isgreater {
	        my($x, $y) = @_;
    		eval q( &__builtin_isgreater(($x), ($y)));
	    }' unless defined(&isgreater);
	    eval 'sub isgreaterequal {
	        my($x, $y) = @_;
    		eval q( &__builtin_isgreaterequal(($x), ($y)));
	    }' unless defined(&isgreaterequal);
	    eval 'sub isless {
	        my($x, $y) = @_;
    		eval q( &__builtin_isless(($x), ($y)));
	    }' unless defined(&isless);
	    eval 'sub islessequal {
	        my($x, $y) = @_;
    		eval q( &__builtin_islessequal(($x), ($y)));
	    }' unless defined(&islessequal);
	    eval 'sub islessgreater {
	        my($x, $y) = @_;
    		eval q( &__builtin_islessgreater(($x), ($y)));
	    }' unless defined(&islessgreater);
	    eval 'sub isunordered {
	        my($x, $y) = @_;
    		eval q( &__builtin_isunordered(($x), ($y)));
	    }' unless defined(&isunordered);
	} else {
	    eval 'sub isgreater {
	        my($x, $y) = @_;
    		eval q((! &isunordered(($x), ($y))  && ($x) > ($y)));
	    }' unless defined(&isgreater);
	    eval 'sub isgreaterequal {
	        my($x, $y) = @_;
    		eval q((! &isunordered(($x), ($y))  && ($x) >= ($y)));
	    }' unless defined(&isgreaterequal);
	    eval 'sub isless {
	        my($x, $y) = @_;
    		eval q((! &isunordered(($x), ($y))  && ($x) < ($y)));
	    }' unless defined(&isless);
	    eval 'sub islessequal {
	        my($x, $y) = @_;
    		eval q((! &isunordered(($x), ($y))  && ($x) <= ($y)));
	    }' unless defined(&islessequal);
	    eval 'sub islessgreater {
	        my($x, $y) = @_;
    		eval q((! &isunordered(($x), ($y))  && (($x) > ($y) || ($y) > ($x))));
	    }' unless defined(&islessgreater);
	    eval 'sub isunordered {
	        my($x, $y) = @_;
    		eval q(( &isnan($x) ||  &isnan($y)));
	    }' unless defined(&isunordered);
	}
	eval 'sub signbit {
	    my($x) = @_;
    	    eval q((($sizeof{$x} == $sizeof{\'float\'}) ?  &__signbitf($x) : ($sizeof{$x} == $sizeof{\'double\'}) ?  &__signbit($x) :  &__signbitl($x)));
	}' unless defined(&signbit);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef) || (defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : undef)) {
	eval 'sub M_E () {2.7182818284590452354;}' unless defined(&M_E);
	eval 'sub M_LOG2E () {1.4426950408889634074;}' unless defined(&M_LOG2E);
	eval 'sub M_LOG10E () {0.43429448190325182765;}' unless defined(&M_LOG10E);
	eval 'sub M_LN2 () {0.69314718055994530942;}' unless defined(&M_LN2);
	eval 'sub M_LN10 () {2.30258509299404568402;}' unless defined(&M_LN10);
	eval 'sub M_PI () {3.14159265358979323846;}' unless defined(&M_PI);
	eval 'sub M_PI_2 () {1.57079632679489661923;}' unless defined(&M_PI_2);
	eval 'sub M_PI_4 () {0.78539816339744830962;}' unless defined(&M_PI_4);
	eval 'sub M_1_PI () {0.31830988618379067154;}' unless defined(&M_1_PI);
	eval 'sub M_2_PI () {0.63661977236758134308;}' unless defined(&M_2_PI);
	eval 'sub M_2_SQRTPI () {1.12837916709551257390;}' unless defined(&M_2_SQRTPI);
	eval 'sub M_SQRT2 () {1.41421356237309504880;}' unless defined(&M_SQRT2);
	eval 'sub M_SQRT1_2 () {0.70710678118654752440;}' unless defined(&M_SQRT1_2);
	eval 'sub MAXFLOAT () {(3.40282346638528860e+38);}' unless defined(&MAXFLOAT);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	if(0) {
	    eval 'sub HUGE () { &HUGE_VAL;}' unless defined(&HUGE);
	} else {
	    eval 'sub HUGE () { &MAXFLOAT;}' unless defined(&HUGE);
	}
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef) || (defined(&__ISO_C_VISIBLE) ? &__ISO_C_VISIBLE : undef) >= 1999|| (defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : undef)) {
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef) || (defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : undef)) {
	if((defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : undef) <= 500|| (defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	}
	if((defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : undef) <= 600|| (defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	}
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef) || (defined(&__ISO_C_VISIBLE) ? &__ISO_C_VISIBLE : undef) >= 1999) {
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
    }
    if((defined(&__ISO_C_VISIBLE) ? &__ISO_C_VISIBLE : undef) >= 1999) {
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
    }
    if((defined(&__ISO_C_VISIBLE) ? &__ISO_C_VISIBLE : undef) >= 1999) {
	if(0) {
	}
	if(0) {
	}
	if(0) {
	}
	if(0) {
	}
	if(0) {
	}
	if(0) {
	}
	if(0) {
	}
	if(0) {
	}
	if(0) {
	}
	if(0) {
	}
	if(0) {
	}
	if(0) {
	}
	if(0) {
	}
	if(0) {
	}
    }
}
1;
