require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_CPUSET_H_)) {
    eval 'sub _SYS_CPUSET_H_ () {1;}' unless defined(&_SYS_CPUSET_H_);
    if(defined(&_KERNEL)) {
	eval 'sub CPU_SETSIZE () { &MAXCPU;}' unless defined(&CPU_SETSIZE);
    }
    eval 'sub CPU_MAXSIZE () {128;}' unless defined(&CPU_MAXSIZE);
    unless(defined(&CPU_SETSIZE)) {
	eval 'sub CPU_SETSIZE () { &CPU_MAXSIZE;}' unless defined(&CPU_SETSIZE);
    }
    eval 'sub _NCPUBITS () {($sizeof{\'long\'} *  &NBBY);}' unless defined(&_NCPUBITS);
    eval 'sub _NCPUWORDS () { &howmany( &CPU_SETSIZE,  &_NCPUBITS);}' unless defined(&_NCPUWORDS);
    eval 'sub __cpuset_mask {
        my($n) = @_;
	    eval q((1<< (($n) %  &_NCPUBITS)));
    }' unless defined(&__cpuset_mask);
    eval 'sub CPU_CLR {
        my($n, $p) = @_;
	    eval q((($p)-> $__bits[($n)/ &_NCPUBITS] &= ~ &__cpuset_mask($n)));
    }' unless defined(&CPU_CLR);
    eval 'sub CPU_COPY {
        my($f, $t) = @_;
	    eval q(( &void)(*($t) = *($f)));
    }' unless defined(&CPU_COPY);
    eval 'sub CPU_ISSET {
        my($n, $p) = @_;
	    eval q(((($p)-> $__bits[($n)/ &_NCPUBITS] &  &__cpuset_mask($n)) != 0));
    }' unless defined(&CPU_ISSET);
    eval 'sub CPU_SET {
        my($n, $p) = @_;
	    eval q((($p)-> $__bits[($n)/ &_NCPUBITS] |=  &__cpuset_mask($n)));
    }' unless defined(&CPU_SET);
    eval 'sub CPU_ZERO {
        my($p) = @_;
	    eval q( &do {  &__size_t  &__i;  &for ( &__i = 0;  &__i <  &_NCPUWORDS;  &__i++) ($p)-> $__bits[ &__i] = 0; }  &while (0));
    }' unless defined(&CPU_ZERO);
    eval 'sub CPU_FILL {
        my($p) = @_;
	    eval q( &do {  &__size_t  &__i;  &for ( &__i = 0;  &__i <  &_NCPUWORDS;  &__i++) ($p)-> $__bits[ &__i] = -1; }  &while (0));
    }' unless defined(&CPU_FILL);
    eval 'sub CPU_EMPTY {
        my($p) = @_;
	    eval q( &__extension__ ({  &__size_t  &__i;  &for ( &__i = 0;  &__i <  &_NCPUWORDS;  &__i++)  &if (($p)-> $__bits[ &__i])  &break;  &__i ==  &_NCPUWORDS; }));
    }' unless defined(&CPU_EMPTY);
    eval 'sub CPU_SUBSET {
        my($p, $c) = @_;
	    eval q( &__extension__ ({  &__size_t  &__i;  &for ( &__i = 0;  &__i <  &_NCPUWORDS;  &__i++)  &if ((($c)-> $__bits[ &__i] & ($p)-> $__bits[ &__i]) != ($c)-> $__bits[ &__i])  &break;  &__i ==  &_NCPUWORDS; }));
    }' unless defined(&CPU_SUBSET);
    eval 'sub CPU_OVERLAP {
        my($p, $c) = @_;
	    eval q( &__extension__ ({  &__size_t  &__i;  &for ( &__i = 0;  &__i <  &_NCPUWORDS;  &__i++)  &if ((($c)-> $__bits[ &__i] & ($p)-> $__bits[ &__i]) != 0)  &break;  &__i !=  &_NCPUWORDS; }));
    }' unless defined(&CPU_OVERLAP);
    eval 'sub CPU_CMP {
        my($p, $c) = @_;
	    eval q( &__extension__ ({  &__size_t  &__i;  &for ( &__i = 0;  &__i <  &_NCPUWORDS;  &__i++)  &if ((($c)-> $__bits[ &__i] != ($p)-> $__bits[ &__i]))  &break;  &__i !=  &_NCPUWORDS; }));
    }' unless defined(&CPU_CMP);
    eval 'sub CPU_OR {
        my($d, $s) = @_;
	    eval q( &do {  &__size_t  &__i;  &for ( &__i = 0;  &__i <  &_NCPUWORDS;  &__i++) ($d)-> $__bits[ &__i] |= ($s)-> $__bits[ &__i]; }  &while (0));
    }' unless defined(&CPU_OR);
    eval 'sub CPU_AND {
        my($d, $s) = @_;
	    eval q( &do {  &__size_t  &__i;  &for ( &__i = 0;  &__i <  &_NCPUWORDS;  &__i++) ($d)-> $__bits[ &__i] &= ($s)-> $__bits[ &__i]; }  &while (0));
    }' unless defined(&CPU_AND);
    eval 'sub CPU_NAND {
        my($d, $s) = @_;
	    eval q( &do {  &__size_t  &__i;  &for ( &__i = 0;  &__i <  &_NCPUWORDS;  &__i++) ($d)-> $__bits[ &__i] &= ~($s)-> $__bits[ &__i]; }  &while (0));
    }' unless defined(&CPU_NAND);
    eval 'sub CPU_LEVEL_ROOT () {1;}' unless defined(&CPU_LEVEL_ROOT);
    eval 'sub CPU_LEVEL_CPUSET () {2;}' unless defined(&CPU_LEVEL_CPUSET);
    eval 'sub CPU_LEVEL_WHICH () {3;}' unless defined(&CPU_LEVEL_WHICH);
    eval 'sub CPU_WHICH_TID () {1;}' unless defined(&CPU_WHICH_TID);
    eval 'sub CPU_WHICH_PID () {2;}' unless defined(&CPU_WHICH_PID);
    eval 'sub CPU_WHICH_CPUSET () {3;}' unless defined(&CPU_WHICH_CPUSET);
    eval 'sub CPU_WHICH_IRQ () {4;}' unless defined(&CPU_WHICH_IRQ);
    eval 'sub CPU_WHICH_JAIL () {5;}' unless defined(&CPU_WHICH_JAIL);
    eval 'sub CPUSET_INVALID () {-1;}' unless defined(&CPUSET_INVALID);
    eval 'sub CPUSET_DEFAULT () {0;}' unless defined(&CPUSET_DEFAULT);
    if(defined(&_KERNEL)) {
	eval 'sub CPU_SET_ROOT () {0x1;}' unless defined(&CPU_SET_ROOT);
	eval 'sub CPU_SET_RDONLY () {0x2;}' unless defined(&CPU_SET_RDONLY);
    } else {
    }
}
1;
