require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_SDT_H)) {
    eval 'sub _SYS_SDT_H () {1;}' unless defined(&_SYS_SDT_H);
    unless(defined(&_KERNEL)) {
	eval 'sub _DTRACE_VERSION () {1;}' unless defined(&_DTRACE_VERSION);
	eval 'sub DTRACE_PROBE {
	    my($prov, $name) = @_;
    	    eval q({  &extern  &void  &__dtrace_$prov &___$name( &void);  &__dtrace_$prov &___$name(); });
	}' unless defined(&DTRACE_PROBE);
	eval 'sub DTRACE_PROBE1 {
	    my($prov, $name, $arg1) = @_;
    	    eval q({  &extern  &void  &__dtrace_$prov &___$name;  &__dtrace_$prov &___$name($arg1); });
	}' unless defined(&DTRACE_PROBE1);
	eval 'sub DTRACE_PROBE2 {
	    my($prov, $name, $arg1, $arg2) = @_;
    	    eval q({  &extern  &void  &__dtrace_$prov &___$name(\'unsigned long\', \'unsigned long\');  &__dtrace_$prov &___$name($arg1, $arg2); });
	}' unless defined(&DTRACE_PROBE2);
	eval 'sub DTRACE_PROBE3 {
	    my($prov, $name, $arg1, $arg2, $arg3) = @_;
    	    eval q({  &extern  &void  &__dtrace_$prov &___$name(\'unsigned long\', \'unsigned long\', \'unsigned long\');  &__dtrace_$prov &___$name($arg1, $arg2, $arg3); });
	}' unless defined(&DTRACE_PROBE3);
	eval 'sub DTRACE_PROBE4 {
	    my($prov, $name, $arg1, $arg2, $arg3, $arg4) = @_;
    	    eval q({  &extern  &void  &__dtrace_$prov &___$name(\'unsigned long\', \'unsigned long\', \'unsigned long\', \'unsigned long\');  &__dtrace_$prov &___$name($arg1, $arg2, $arg3, $arg4); });
	}' unless defined(&DTRACE_PROBE4);
	eval 'sub DTRACE_PROBE5 {
	    my($prov, $name, $arg1, $arg2, $arg3, $arg4, $arg5) = @_;
    	    eval q({  &extern  &void  &__dtrace_$prov &___$name(\'unsigned long\', \'unsigned long\', \'unsigned long\', \'unsigned long\', \'unsigned long\');  &__dtrace_$prov &___$name($arg1, $arg2, $arg3, $arg4, $arg5); });
	}' unless defined(&DTRACE_PROBE5);
    } else {
	unless(defined(&KDTRACE_HOOKS)) {
	    eval 'sub SDT_PROVIDER_DEFINE {
	        my($prov) = @_;
    		eval q();
	    }' unless defined(&SDT_PROVIDER_DEFINE);
	    eval 'sub SDT_PROVIDER_DECLARE {
	        my($prov) = @_;
    		eval q();
	    }' unless defined(&SDT_PROVIDER_DECLARE);
	    eval 'sub SDT_PROBE_DEFINE {
	        my($prov, $mod, $func, $name, $sname) = @_;
    		eval q();
	    }' unless defined(&SDT_PROBE_DEFINE);
	    eval 'sub SDT_PROBE_DECLARE {
	        my($prov, $mod, $func, $name) = @_;
    		eval q();
	    }' unless defined(&SDT_PROBE_DECLARE);
	    eval 'sub SDT_PROBE {
	        my($prov, $mod, $func, $name, $arg0, $arg1, $arg2, $arg3, $arg4) = @_;
    		eval q();
	    }' unless defined(&SDT_PROBE);
	    eval 'sub SDT_PROBE_ARGTYPE {
	        my($prov, $mod, $func, $name, $num, $type) = @_;
    		eval q();
	    }' unless defined(&SDT_PROBE_ARGTYPE);
	    eval 'sub SDT_PROBE_DEFINE1 {
	        my($prov, $mod, $func, $name, $sname, $arg0) = @_;
    		eval q();
	    }' unless defined(&SDT_PROBE_DEFINE1);
	    eval 'sub SDT_PROBE_DEFINE2 {
	        my($prov, $mod, $func, $name, $sname, $arg0, $arg1) = @_;
    		eval q();
	    }' unless defined(&SDT_PROBE_DEFINE2);
	    eval 'sub SDT_PROBE_DEFINE3 {
	        my($prov, $mod, $func, $name, $sname, $arg0, $arg1, $arg2) = @_;
    		eval q();
	    }' unless defined(&SDT_PROBE_DEFINE3);
	    eval 'sub SDT_PROBE_DEFINE4 {
	        my($prov, $mod, $func, $name, $sname, $arg0, $arg1, $arg2, $arg3) = @_;
    		eval q();
	    }' unless defined(&SDT_PROBE_DEFINE4);
	    eval 'sub SDT_PROBE_DEFINE5 {
	        my($prov, $mod, $func, $name, $sname, $arg0, $arg1, $arg2, $arg3, $arg4) = @_;
    		eval q();
	    }' unless defined(&SDT_PROBE_DEFINE5);
	    eval 'sub SDT_PROBE0 {
	        my($prov, $mod, $func, $name) = @_;
    		eval q();
	    }' unless defined(&SDT_PROBE0);
	    eval 'sub SDT_PROBE1 {
	        my($prov, $mod, $func, $name, $arg0) = @_;
    		eval q();
	    }' unless defined(&SDT_PROBE1);
	    eval 'sub SDT_PROBE2 {
	        my($prov, $mod, $func, $name, $arg0, $arg1) = @_;
    		eval q();
	    }' unless defined(&SDT_PROBE2);
	    eval 'sub SDT_PROBE3 {
	        my($prov, $mod, $func, $name, $arg0, $arg1, $arg2) = @_;
    		eval q();
	    }' unless defined(&SDT_PROBE3);
	    eval 'sub SDT_PROBE4 {
	        my($prov, $mod, $func, $name, $arg0, $arg1, $arg2, $arg3) = @_;
    		eval q();
	    }' unless defined(&SDT_PROBE4);
	    eval 'sub SDT_PROBE5 {
	        my($prov, $mod, $func, $name, $arg0, $arg1, $arg2, $arg3, $arg4) = @_;
    		eval q();
	    }' unless defined(&SDT_PROBE5);
	} else {
	    eval("sub SDT_UNINIT () { 1; }") unless defined(&SDT_UNINIT);
	    eval("sub SDT_INIT () { 2; }") unless defined(&SDT_INIT);
	    eval 'sub SDT_PROVIDER_DEFINE {
	        my($prov) = @_;
    		eval q(\'struct sdt_provider\'  &sdt_provider_$prov->[1] = { { $prov, {  &NULL,  &NULL }, {  &NULL,  &NULL } } };  &SYSINIT( &sdt_provider_$prov &_init,  &SI_SUB_KDTRACE,  &SI_ORDER_SECOND,  &sdt_provider_register,  &sdt_provider_$prov );  &SYSUNINIT( &sdt_provider_$prov &_uninit,  &SI_SUB_KDTRACE,  &SI_ORDER_SECOND,  &sdt_provider_deregister,  &sdt_provider_$prov ));
	    }' unless defined(&SDT_PROVIDER_DEFINE);
	    eval 'sub SDT_PROVIDER_DECLARE {
	        my($prov) = @_;
    		eval q( &extern \'struct sdt_provider\'  &sdt_provider_$prov->[1]);
	    }' unless defined(&SDT_PROVIDER_DECLARE);
	    eval 'sub SDT_PROBE_DEFINE {
	        my($prov, $mod, $func, $name, $sname) = @_;
    		eval q(\'struct sdt_probe\'  &sdt_$prov &_$mod &_$func &_$name->[1] = { { $sizeof{\'struct sdt_probe\'}, 0,  &sdt_provider_$prov, {  &NULL,  &NULL }, {  &NULL,  &NULL }, $mod, $func, $sname, 0, 0} };  &SYSINIT( &sdt_$prov &_$mod &_$func &_$name &_init,  &SI_SUB_KDTRACE,  &SI_ORDER_SECOND + 1,  &sdt_probe_register,  &sdt_$prov &_$mod &_$func &_$name );  &SYSUNINIT( &sdt_$prov &_$mod &_$func &_$name &_uninit,  &SI_SUB_KDTRACE,  &SI_ORDER_SECOND + 1,  &sdt_probe_deregister,  &sdt_$prov &_$mod &_$func &_$name ));
	    }' unless defined(&SDT_PROBE_DEFINE);
	    eval 'sub SDT_PROBE_DECLARE {
	        my($prov, $mod, $func, $name) = @_;
    		eval q( &extern \'struct sdt_probe\'  &sdt_$prov &_$mod &_$func &_$name->[1]);
	    }' unless defined(&SDT_PROBE_DECLARE);
	    eval 'sub SDT_PROBE {
	        my($prov, $mod, $func, $name, $arg0, $arg1, $arg2, $arg3, $arg4) = @_;
    		eval q( &if ( &sdt_$prov &_$mod &_$func &_ ($name->{id})) (* &sdt_probe_func)( &sdt_$prov &_$mod &_$func &_ ($name->{id}), ( &uintptr_t) $arg0, ( &uintptr_t) $arg1, ( &uintptr_t) $arg2, ( &uintptr_t) $arg3, ( &uintptr_t) $arg4));
	    }' unless defined(&SDT_PROBE);
	    eval 'sub SDT_PROBE_ARGTYPE {
	        my($prov, $mod, $func, $name, $num, $type) = @_;
    		eval q(\'struct sdt_argtype\'  &sdt_$prov &_$mod &_$func &_$name$num->[1] = { { $num, $type, {  &NULL,  &NULL },  &sdt_$prov &_$mod &_$func &_$name } };  &SYSINIT( &sdt_$prov &_$mod &_$func &_$name$num &_init,  &SI_SUB_KDTRACE,  &SI_ORDER_SECOND + 2,  &sdt_argtype_register,  &sdt_$prov &_$mod &_$func &_$name$num );  &SYSUNINIT( &sdt_$prov &_$mod &_$func &_$name$num &_uninit,  &SI_SUB_KDTRACE,  &SI_ORDER_SECOND + 2,  &sdt_argtype_deregister,  &sdt_$prov &_$mod &_$func &_$name$num ));
	    }' unless defined(&SDT_PROBE_ARGTYPE);
	    eval 'sub SDT_PROBE_DEFINE1 {
	        my($prov, $mod, $func, $name, $sname, $arg0) = @_;
    		eval q( &SDT_PROBE_DEFINE($prov, $mod, $func, $name, $sname);  &SDT_PROBE_ARGTYPE($prov, $mod, $func, $name, 0, $arg0));
	    }' unless defined(&SDT_PROBE_DEFINE1);
	    eval 'sub SDT_PROBE_DEFINE2 {
	        my($prov, $mod, $func, $name, $sname, $arg0, $arg1) = @_;
    		eval q( &SDT_PROBE_DEFINE($prov, $mod, $func, $name, $sname);  &SDT_PROBE_ARGTYPE($prov, $mod, $func, $name, 0, $arg0);  &SDT_PROBE_ARGTYPE($prov, $mod, $func, $name, 1, $arg1));
	    }' unless defined(&SDT_PROBE_DEFINE2);
	    eval 'sub SDT_PROBE_DEFINE3 {
	        my($prov, $mod, $func, $name, $sname, $arg0, $arg1, $arg2) = @_;
    		eval q( &SDT_PROBE_DEFINE($prov, $mod, $func, $name, $sname);  &SDT_PROBE_ARGTYPE($prov, $mod, $func, $name, 0, $arg0);  &SDT_PROBE_ARGTYPE($prov, $mod, $func, $name, 1, $arg1);  &SDT_PROBE_ARGTYPE($prov, $mod, $func, $name, 2, $arg2));
	    }' unless defined(&SDT_PROBE_DEFINE3);
	    eval 'sub SDT_PROBE_DEFINE4 {
	        my($prov, $mod, $func, $name, $sname, $arg0, $arg1, $arg2, $arg3) = @_;
    		eval q( &SDT_PROBE_DEFINE($prov, $mod, $func, $name, $sname);  &SDT_PROBE_ARGTYPE($prov, $mod, $func, $name, 0, $arg0);  &SDT_PROBE_ARGTYPE($prov, $mod, $func, $name, 1, $arg1);  &SDT_PROBE_ARGTYPE($prov, $mod, $func, $name, 2, $arg2);  &SDT_PROBE_ARGTYPE($prov, $mod, $func, $name, 3, $arg3));
	    }' unless defined(&SDT_PROBE_DEFINE4);
	    eval 'sub SDT_PROBE_DEFINE5 {
	        my($prov, $mod, $func, $name, $sname, $arg0, $arg1, $arg2, $arg3, $arg4) = @_;
    		eval q( &SDT_PROBE_DEFINE($prov, $mod, $func, $name, $sname);  &SDT_PROBE_ARGTYPE($prov, $mod, $func, $name, 0, $arg0);  &SDT_PROBE_ARGTYPE($prov, $mod, $func, $name, 1, $arg1);  &SDT_PROBE_ARGTYPE($prov, $mod, $func, $name, 2, $arg2);  &SDT_PROBE_ARGTYPE($prov, $mod, $func, $name, 3, $arg3);  &SDT_PROBE_ARGTYPE($prov, $mod, $func, $name, 4, $arg4));
	    }' unless defined(&SDT_PROBE_DEFINE5);
	    eval 'sub SDT_PROBE0 {
	        my($prov, $mod, $func, $name) = @_;
    		eval q( &SDT_PROBE($prov, $mod, $func, $name, 0, 0, 0, 0, 0));
	    }' unless defined(&SDT_PROBE0);
	    eval 'sub SDT_PROBE1 {
	        my($prov, $mod, $func, $name, $arg0) = @_;
    		eval q( &SDT_PROBE($prov, $mod, $func, $name, $arg0, 0, 0, 0, 0));
	    }' unless defined(&SDT_PROBE1);
	    eval 'sub SDT_PROBE2 {
	        my($prov, $mod, $func, $name, $arg0, $arg1) = @_;
    		eval q( &SDT_PROBE($prov, $mod, $func, $name, $arg0, $arg1, 0, 0, 0));
	    }' unless defined(&SDT_PROBE2);
	    eval 'sub SDT_PROBE3 {
	        my($prov, $mod, $func, $name, $arg0, $arg1, $arg2) = @_;
    		eval q( &SDT_PROBE($prov, $mod, $func, $name, $arg0, $arg1, $arg2, 0, 0));
	    }' unless defined(&SDT_PROBE3);
	    eval 'sub SDT_PROBE4 {
	        my($prov, $mod, $func, $name, $arg0, $arg1, $arg2, $arg3) = @_;
    		eval q( &SDT_PROBE($prov, $mod, $func, $name, $arg0, $arg1, $arg2, $arg3, 0));
	    }' unless defined(&SDT_PROBE4);
	    eval 'sub SDT_PROBE5 {
	        my($prov, $mod, $func, $name, $arg0, $arg1, $arg2, $arg3, $arg4) = @_;
    		eval q( &SDT_PROBE($prov, $mod, $func, $name, $arg0, $arg1, $arg2, $arg3, $arg4));
	    }' unless defined(&SDT_PROBE5);
	}
    }
}
1;
