require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_SYSTM_H_)) {
    eval 'sub _SYS_SYSTM_H_ () {1;}' unless defined(&_SYS_SYSTM_H_);
    require 'machine/atomic.ph';
    require 'machine/cpufunc.ph';
    require 'sys/callout.ph';
    require 'sys/cdefs.ph';
    require 'sys/queue.ph';
    require 'sys/stdint.ph';
    eval("sub VM_GUEST_NO () { 0; }") unless defined(&VM_GUEST_NO);
    eval("sub VM_GUEST_VM () { 1; }") unless defined(&VM_GUEST_VM);
    eval("sub VM_GUEST_XEN () { 2; }") unless defined(&VM_GUEST_XEN);
    if(defined(&INVARIANTS)) {
	eval 'sub KASSERT {
	    my($exp,$msg) = @_;
    	    eval q( &do {  &if ( &__predict_false(!($exp)))  &panic $msg; }  &while (0));
	}' unless defined(&KASSERT);
	eval 'sub VNASSERT {
	    my($exp, $vp, $msg) = @_;
    	    eval q( &do {  &if ( &__predict_false(!($exp))) {  &vn_printf($vp, \\"VNASSERT failed\\\\n\\");  &panic $msg; } }  &while (0));
	}' unless defined(&VNASSERT);
    } else {
	eval 'sub KASSERT {
	    my($exp,$msg) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&KASSERT);
	eval 'sub VNASSERT {
	    my($exp, $vp, $msg) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&VNASSERT);
    }
    unless(defined(&CTASSERT)) {
	eval 'sub CTASSERT {
	    my($x) = @_;
    	    eval q( &_CTASSERT($x,  &__LINE__));
	}' unless defined(&CTASSERT);
	eval 'sub _CTASSERT {
	    my($x, $y) = @_;
    	    eval q( &__CTASSERT($x, $y));
	}' unless defined(&_CTASSERT);
	eval 'sub __CTASSERT {
	    my($x, $y) = @_;
    	    eval q( &typedef \'char\'  &__assert  $y->[($x) ? 1: -1]);
	}' unless defined(&__CTASSERT);
    }
    eval 'sub ASSERT_ATOMIC_LOAD_PTR {
        my($var, $msg) = @_;
	    eval q( &KASSERT($sizeof{$var} == $sizeof{ &void }  && (( &uintptr_t)($var) & ($sizeof{ &void } - 1)) == 0, $msg));
    }' unless defined(&ASSERT_ATOMIC_LOAD_PTR);
    eval 'sub SCHEDULER_STOPPED () {
        eval q( &__predict_false( ($curthread->{td_stopsched})));
    }' unless defined(&SCHEDULER_STOPPED);
    eval 'sub HASH_NOWAIT () {0x1;}' unless defined(&HASH_NOWAIT);
    eval 'sub HASH_WAITOK () {0x2;}' unless defined(&HASH_WAITOK);
    if(defined(&RESTARTABLE_PANICS)) {
    } else {
    }
    eval 'sub HD_COLUMN_MASK () {0xff;}' unless defined(&HD_COLUMN_MASK);
    eval 'sub HD_DELIM_MASK () {0xff00;}' unless defined(&HD_DELIM_MASK);
    eval 'sub HD_OMIT_COUNT () {(1<< 16);}' unless defined(&HD_OMIT_COUNT);
    eval 'sub HD_OMIT_HEX () {(1<< 17);}' unless defined(&HD_OMIT_HEX);
    eval 'sub HD_OMIT_CHARS () {(1<< 18);}' unless defined(&HD_OMIT_CHARS);
    eval 'sub ovbcopy {
        my($f, $t, $l) = @_;
	    eval q( &bcopy(($f), ($t), ($l)));
    }' unless defined(&ovbcopy);
    if(defined(&APM_FIXUP_CALLTODO)) {
    }
    require 'sys/libkern.ph';
    eval 'sub CALLOUT_HANDLE_INITIALIZER {
        my($handle) = @_;
	    eval q({  &NULL });
    }' unless defined(&CALLOUT_HANDLE_INITIALIZER);
    eval 'sub splx {
        my($__unused) = @_;
	    eval q({ ; } \'int\'  &_sleep( &void * &chan, \'struct lock_object\' * &lock, \'int\'  &pri,  &const \'char\' * &wmesg, \'int\'  &timo)  &__nonnull(1);  &define  &msleep( &chan,  &mtx,  &pri,  &wmesg,  &timo)  &_sleep(( &chan), ( &mtx)-> &lock_object, ( &pri), ( &wmesg), ( &timo)) \'int\'  &msleep_spin( &void * &chan, \'struct mtx\' * &mtx,  &const \'char\' * &wmesg, \'int\'  &timo)  &__nonnull(1); \'int\'  &pause( &const \'char\' * &wmesg, \'int\'  &timo);  &define  &tsleep( &chan,  &pri,  &wmesg,  &timo)  &_sleep(( &chan),  &NULL, ( &pri), ( &wmesg), ( &timo))  &void  &wakeup( &void * &chan)  &__nonnull(1);  &void  &wakeup_one( &void * &chan)  &__nonnull(1); \'struct cdev\';  &dev_t  &dev2udev(\'struct cdev\' * &x);  &const \'char\' * &devtoname(\'struct cdev\' * &cdev); \'int\'  &poll_no_poll(\'int\'  &events);  &void  &DELAY(\'int\'  &usec); \'struct root_hold_token\'; \'struct root_hold_token\' * &root_mount_hold( &const \'char\' * &identifier);  &void  &root_mount_rel(\'struct root_hold_token\' * &h);  &void  &root_mount_wait( &void); \'int\'  &root_mounted( &void); \'struct unrhdr\'; \'struct unrhdr\' * &new_unrhdr(\'int\'  &low, \'int\'  &high, \'struct mtx\' * &mutex);  &void  &delete_unrhdr(\'struct unrhdr\' * &uh);  &void  &clean_unrhdr(\'struct unrhdr\' * &uh);  &void  &clean_unrhdrl(\'struct unrhdr\' * &uh); \'int\'  &alloc_unr(\'struct unrhdr\' * &uh); \'int\'  &alloc_unr_specific(\'struct unrhdr\' * &uh, \'u_int\'  &item); \'int\'  &alloc_unrl(\'struct unrhdr\' * &uh);  &void  &free_unr(\'struct unrhdr\' * &uh, \'u_int\'  &item);  &uint32_t  &bitcount32( &uint32_t  &x) {  &x = ( &x & 0x55555555) + (( &x & 0xaaaaaaaa) >> 1);  &x = ( &x & 0x33333333) + (( &x & 0xcccccccc) >> 2);  &x = ( &x + ( &x >> 4)) & 0xf0f0f0f;  &x = ( &x + ( &x >> 8));  &x = ( &x + ( &x >> 16)) & 0xff; ( &x); });
    }' unless defined(&splx);
    eval 'sub bitcount16 {
        my($x) = @_;
	    eval q({ $x = ($x & 0x5555) + (($x & 0xaaaa) >> 1); $x = ($x & 0x3333) + (($x & 0xcccc) >> 2); $x = ($x + ($x >> 4)) & 0xf0f; $x = ($x + ($x >> 8)) & 0xff; ($x); });
    }' unless defined(&bitcount16);
}
1;
